; a-stern-Labyrint-listen.scm
;;; a* (nicht iterativ) beim kürzesten Weg
(load "breakpoint.scm")
;;; ===== Kanten mit Rueckkanten =====
(load "a-stern-gross-daten.scm")
; Die Kanten werden mit beiden Richtungen erzeugt, so dass der
; jeweilige Zielknoten an zweiter Stelle in der Liste steht.
; -> Hilfsfunktion ergaenze-um-rueckkanten in a-stern-gross-daten.scm

(load "wege.scm")
;;; --------------------
; Das Programm benoetigt ausserdem die ausgegliederte Funktion:
(load "prioritaetswarteschlange-a-stern.scm")
; mit der Funktion (fuege-alle-ein <wegeliste> vor? start ziel <priows>)
; Wege: (<aktuelle-laenge> <umgekehrte-reihenfolge-der-knoten>)
; Das Praedikat vor? muss dafuer definiert werden:
(define
  (vor? weg-1 weg-2 ziel)
  (< (kosten weg-1 ziel) (kosten weg-2 ziel)))
; und damit auch die Funktionen fuer die ...
; gesamtkosten
(define
  (kosten weg ziel)
  (+
   (aktuelle-kosten weg)
   (restkosten weg ziel)))
; aktuellen Kosten (endrekursiv!)
(define
  (aktuelle-kosten weg)
  (first weg))

; und die Restkosten
(define
  (restkosten weg ziel)
  (sqrt (+
         (sqr (- (gibX (second weg)) (gibX ziel)))
         (sqr (- (gibY (second weg)) (gibY ziel)))
         )))

;;; ===== Datenstrukturen ===== 
;;;Liste aller Knoten:
;;;((<name> <x-koordinate> <y-koordinate>) ...)
;;;Liste aller Kanten:
;;;((<name-von> <name-nach> laenge) ... ),
;;; jeweils nur eine 'Richtung' von beiden angegeben
;
;;; =============== Entwurfsprinzip fuer A* ===============
;;; Durch das Verwenden der Prioritaetswarteschlange ist gewaehrleistet,
;;; dass nur die kuerzesten Wege (nach den Gesamtkosten) zu einem Knoten
;;; verwendet werden.
;;; Varianten:
; - Es wird nur der kuerzeste Weg zu einem Zielknoten gesucht.
; - Es werden alle kuerzesten Wege vom Startknoten aus gesucht.
;;; Entwurfentscheidung: Variante 1 wird bearbeitet.

;;; ===== a-stern =====
; Loesung mit passender Aufrufhuelle
(define
  (a-stern start-knoten ziel-knoten graph)
  (define
    (a-stern-intern besucht kuerzeste-wege priows)
    (cond
      ((null? priows)
       #f)
      ((equal? (second (first priows)) ziel-knoten)
       ;(display kuerzeste-wege)(display #\newline)(display "Loesung: ")
       (reverse (first priows)))
      ((member (second (first priows)) besucht)
       (a-stern-intern
        besucht
        kuerzeste-wege
        (rest priows)))
      (else
       (a-stern-intern
        (aktualisiere-besuchtliste (second (first priows)) besucht)
        (aktualisisere-kuerzeste-wege
         besucht
         (first priows)
         kuerzeste-wege)
        (aktualisiere-priows priows ziel-knoten graph)))
      )) ; Ende interne Funktion
  ; interner Aufruf:
  (a-stern-intern
   (list start-knoten)
   '()
   (fuege-alle-ein ; Start-PrioWS
    (alle-nachfolge-wege
     (list 0 start-knoten) ; Start-'Weg'
     graph)
    vor?
    ziel-knoten
    '())
   ))

;;; ===== Hilfsfunktion aktualisiere-besuchtliste =====
(define
  (aktualisiere-besuchtliste knoten besucht)
  (if
   (member knoten besucht)
   besucht
   (cons knoten besucht)
   ))

;;; ===== Hilfsfunktion aktualisiere-priows =====
; Zum ersten Weg aus der Prioritaetswarteschlange werden alle weiter fuehrenden
; wege bestimmt und in den Rest der priows eingefuegt
(define
  (aktualisiere-priows priows ziel graph)
  (fuege-alle-ein
   (alle-nachfolge-wege
    (first priows)
    graph)
   vor?
   ziel
   (rest priows)))

;;; ===== Hilfsfunktion aktualisisere-kuerzeste-wege =====
; Nur neu erreichte Knoten ergeben einen kuerzesten Weg
(define
  (aktualisisere-kuerzeste-wege besucht weg kuerzeste-wege)
  (if
   (member (second weg) besucht)
   kuerzeste-wege
   (cons weg kuerzeste-wege)
   ))

(a-stern  'A 'M (gib-alle-kanten))